"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Client_1 = __importDefault(require("./Client"));
/**
 * Implementação do Cliente para trabalhar com React e ReactNative de forma mais natural
 */
var ClientReact = /** @class */ (function (_super) {
    __extends(ClientReact, _super);
    function ClientReact() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Método específico para trablhar com componentes React/React native
     *
     * Injeta no componente a habilitade de ser atualizado quando receber novas mensagens no tópico,
     * sem a necessidde de remover a referencia quando o componente for removido.
     *
     * Ex.:
     * componentDidMount() {
     *     Client.inject(this, 'grupos', (grupos: Array<Grupo>) => {
     *         this.setState({
     *             grupos: grupos
     *         });
     *     });
     * }
     *
     * @param topic
     * @param callback
     */
    ClientReact.prototype.inject = function (component, topic, callback) {
        var componentUnmounted = false;
        var cancel = this.subscribe(topic, function (data) {
            if (componentUnmounted) {
                cancel();
                return;
            }
            callback(data);
        });
        // Permite ouvir quando o componente não está mais montado, evitando processamento desnecessário
        // https://reactjs.org/blog/2015/12/16/ismounted-antipattern.html
        var bindComponentWillUnmount = (component.componentWillUnmount || new Function).bind(component);
        component.componentWillUnmount = function () {
            componentUnmounted = true;
            cancel();
            bindComponentWillUnmount();
        };
        return cancel;
    };
    return ClientReact;
}(Client_1.default));
exports.default = ClientReact;
//# sourceMappingURL=ClientReact.js.map