"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Topic_1 = __importDefault(require("../Topic"));
var Actions_1 = __importDefault(require("../Actions"));
var Publishers_1 = __importDefault(require("../Publishers"));
/**
 * Permite ao cliente sincronizar a informação sobre a ultima mensagem recebida no tópico
 */
Actions_1.default.register('syncTopic', function (info, ws, accept) {
    var topic = Topic_1.default.find(info.topic);
    if (topic) {
        topic.subscribe(ws, info.seq);
        // Solicita a publicação no tópico, para garantir que o usuário já receba a versão mais recente
        var parts = info.topic.split('#');
        Publishers_1.default.publish(parts[0], parts[1]);
    }
    accept();
});
//# sourceMappingURL=syncTopicAction.js.map