"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Topic_1 = __importDefault(require("../Topic"));
var Actions_1 = __importDefault(require("../Actions"));
var Publishers_1 = __importDefault(require("../Publishers"));
/**
 * Atualiza os registro do ws nos tópicos informados.
 *
 * Remove dos outros tópicos (para que o usuário não receba mensagens desnecessárias)
 *
 * Faz também o controle de criação de tópicos. Alguns tópicos são dinamicos. Ex. avaliacao_candidato#<ID_DO_CANDIDATO>
 */
Actions_1.default.register('syncTopics', function (data, ws, accept) {
    // Criação de novos tópicos, se necessário
    data.forEach(function (item) {
        // Se não existir, será instanciado
        Topic_1.default.find(item.topic);
    });
    // Registra ou Remove o usuário dos tópicos
    Topic_1.default.ALL.forEach(function (topic) {
        var info = data.find(function (item) { return item.topic === topic.getName(); });
        if (info) {
            // Atualiza o cliente no tópico
            topic.subscribe(ws, info.seq);
            // Solicita a publicação no tópico, para garantir que o usuário já receba a versão mais recente
            var parts = info.topic.split('#');
            Publishers_1.default.publish(parts[0], parts[1]);
        }
        else {
            // Cliente não está mais nessa lista
            topic.unsubscribe(ws);
        }
    });
    accept();
});
//# sourceMappingURL=syncTopicsAction.js.map