import Repository from "./Repository";
import { AnyObject } from "../Constants";
/**
 * Data Store em memória, facilita o desenvolvimento de Mock de funcionalidades
 */
export default class InMemoryRepository<T> extends Repository<(T & AnyObject)> {
    SEQUENCE: number;
    ROWS: Array<T & AnyObject>;
    match(query: any, row: any): boolean;
    find(criteria: AnyObject, options: AnyObject): Promise<Array<T & AnyObject>>;
    count(criteria: AnyObject, options: AnyObject): Promise<number>;
    findOne(criteria: AnyObject, options: AnyObject): Promise<T & AnyObject>;
    insert(data: Partial<T & AnyObject>): Promise<T & AnyObject>;
    update(criteria: AnyObject, data: Partial<T & AnyObject>, options?: AnyObject): Promise<number>;
    remove(criteria: AnyObject, options: AnyObject): Promise<number>;
}
