import { AnyObject } from "../Constants";
/**
 * Repositório abstrato, usado pelos tópicos e publishers
 */
export default class Repository<T> {
    find(criteria: AnyObject, options: AnyObject): Promise<Array<T>>;
    count(criteria: AnyObject, options: AnyObject): Promise<number>;
    findOne(criteria: AnyObject, options: AnyObject): Promise<T>;
    insert(data: Partial<T>, options: AnyObject): Promise<T>;
    update(criteria: AnyObject, data: Partial<T>, options: AnyObject): Promise<number>;
    remove(criteria: AnyObject, options: AnyObject): Promise<number>;
}
