"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ClientStorageAbstract_1 = __importDefault(require("./ClientStorageAbstract"));
/**
 * Implementação do ClienteStore em memória
 */
var ClientStorageMemory = /** @class */ (function (_super) {
    __extends(ClientStorageMemory, _super);
    function ClientStorageMemory(namespace, ttl) {
        if (ttl === void 0) { ttl = 10000; }
        var _this = _super.call(this, namespace) || this;
        _this.storage = {};
        _this.ttl = ttl;
        return _this;
    }
    ClientStorageMemory.prototype.getTTL = function (key) {
        key = this.toNamespaceKey(key);
        return this.storage[key] ? ((new Date()).getTime() - this.storage[key].inserted) : -1;
    };
    ClientStorageMemory.prototype.getItem = function (key) {
        var _this = this;
        return new Promise(function (accept, reject) {
            accept(_this.storage[key] ? _this.storage[key].value : null);
        });
    };
    ClientStorageMemory.prototype.setItem = function (key, data) {
        var _this = this;
        return new Promise(function (accept, reject) {
            _this.storage[key] = {
                inserted: (new Date()).getTime(),
                value: data
            };
            setTimeout(function () {
                // Apos expirar, remove o item do cache
                _this.removeItem(key);
            }, _this.ttl);
            accept();
        });
    };
    ClientStorageMemory.prototype.removeItem = function (key) {
        var _this = this;
        return new Promise(function (accept, reject) {
            delete _this.storage[key];
            accept();
        });
    };
    ClientStorageMemory.prototype.keys = function () {
        var _this = this;
        return new Promise(function (accept, reject) {
            var out = [];
            var namespace = "@" + _this.namespace;
            var keys = Object.keys(_this.storage);
            keys.forEach(function (key) {
                if (key && _this.storage.hasOwnProperty(key) && _this.storage[key] !== undefined && key.indexOf(namespace) === 0) {
                    out.push(key);
                }
            });
            accept(out);
        });
    };
    return ClientStorageMemory;
}(ClientStorageAbstract_1.default));
exports.default = ClientStorageMemory;
//# sourceMappingURL=ClientStorageMemory.js.map