"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_native_1 = require("react-native");
var ClientStorageAbstract_1 = __importDefault(require("./ClientStorageAbstract"));
/**
 * Implementação do Storage para ser usado com React Native
 */
var ClientStorageReactNative = /** @class */ (function (_super) {
    __extends(ClientStorageReactNative, _super);
    function ClientStorageReactNative() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ClientStorageReactNative.prototype.getItem = function (key) {
        return new Promise(function (accept, reject) {
            react_native_1.AsyncStorage.getItem(key, function (err, value) {
                if (err) {
                    reject(err);
                }
                else {
                    accept(value);
                }
            });
        });
    };
    ClientStorageReactNative.prototype.setItem = function (key, data) {
        return new Promise(function (accept, reject) {
            react_native_1.AsyncStorage.setItem(key, data, function (err) {
                if (err) {
                    reject(err);
                }
                else {
                    accept();
                }
            });
        });
    };
    ClientStorageReactNative.prototype.removeItem = function (key) {
        return new Promise(function (accept, reject) {
            react_native_1.AsyncStorage.removeItem(key, function (err) {
                if (err) {
                    reject(err);
                }
                else {
                    accept();
                }
            });
        });
    };
    ClientStorageReactNative.prototype.keys = function () {
        var _this = this;
        return new Promise(function (accept, reject) {
            react_native_1.AsyncStorage.getAllKeys(function (err, keys) {
                if (err) {
                    reject(err);
                    return;
                }
                var out = [];
                var namespace = "@" + _this.namespace;
                if (keys) {
                    keys.forEach(function (key) {
                        if (key && key.indexOf(namespace) === 0) {
                            out.push(key);
                        }
                    });
                }
                accept(out);
            });
        });
    };
    return ClientStorageReactNative;
}(ClientStorageAbstract_1.default));
exports.default = ClientStorageReactNative;
//# sourceMappingURL=ClientStorageReactNative.js.map