"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ClientStorageAbstract_1 = __importDefault(require("./ClientStorageAbstract"));
/**
 * Implementação do ClienteStore que usa o window.localStorage
 */
var ClientStorageWebLocal = /** @class */ (function (_super) {
    __extends(ClientStorageWebLocal, _super);
    function ClientStorageWebLocal() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ClientStorageWebLocal.prototype.getItem = function (key) {
        return new Promise(function (accept, reject) {
            accept(window.localStorage.getItem(key));
        });
    };
    ClientStorageWebLocal.prototype.setItem = function (key, data) {
        return new Promise(function (accept, reject) {
            window.localStorage.setItem(key, data);
            accept();
        });
    };
    ClientStorageWebLocal.prototype.removeItem = function (key) {
        return new Promise(function (accept, reject) {
            window.localStorage.removeItem(key);
            accept();
        });
    };
    ClientStorageWebLocal.prototype.keys = function () {
        var _this = this;
        return new Promise(function (accept, reject) {
            var out = [];
            var namespace = "@" + _this.namespace;
            for (var i = 0, l = window.localStorage.length; i <= l; i++) {
                var key = window.localStorage.key(i);
                if (key && key.indexOf(namespace) === 0) {
                    out.push(key);
                }
            }
            accept(out);
        });
    };
    return ClientStorageWebLocal;
}(ClientStorageAbstract_1.default));
exports.default = ClientStorageWebLocal;
//# sourceMappingURL=ClientStorageWebLocal.js.map