export declare type MidleWare<T> = (context: T, next: () => void) => void;
/**
 * Gerenciador de Midlewares genérico
 */
export default class MidlewareManager<T> {
    private middlewares;
    /**
     * Permite adicionar Midlewares
     *
     * @param middlewares Um ou mais midlewares
     * @param name O Wildcard "*" é usado quando se deseja adicionar um midleware para todas as actions (basta não informar a action)
     */
    add(middlewares: MidleWare<T> | Array<MidleWare<T>>, name?: string): void;
    /**
     * Permite remover um Midleware adicionado anteriormente
     *
     * @param name
     * @param middleware
     */
    remove(middleware: MidleWare<T>, name?: string): void;
    /**
     * Executa os MidleWare informados
     *
     * Se o Midleware não acionar o next, o Promise nunca é resolvido (portanto, ignorado)
     *
     * @param event
     * @param context
     */
    exec(names: string | Array<string>, context: T): Promise<any>;
}
